<?php
/**
 * Plugin	timixml @s tinyMCE Mix : PluXml 5.2 to 5.7
 * @version	4.9.2.01
 * @date	03.09.2019
 * @author	Thomas Ingles
 *
 **/

class timixml extends plxPlugin {

	public $valid_path = false;
	/**
	 * Méthode qui supprime un parametre du fichier parameters.xml
	 * @param	param	nom du parametre à supprimer
	 * @return	true si parametre supprimé, false sinon
	 * @author	Sebastien H
	 **/
	public function delParam($param) {//créé dans PluXml-5.4
		if(isset($this->aParams[$param])) {
			unset($this->aParams[$param]);
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Constructeur de la classe timixml
	 * @param	default_lang	langue par défaut utilisée par PluXml
	 * @return	null
	 * @authors	Thomas Ingles
	 **/
	public function __construct($default_lang) {
		parent::__construct($default_lang);# Appel du constructeur de la classe plxPlugin (obligatoire)
		if(defined('PLX_ADMIN')){#Déclaration des hooks pour la zone d'administration
			# droits pour accéder à la page config.php du plugin
			$this->setConfigProfil(PROFIL_ADMIN);
			$this->addHook('AdminTopBottom', 'AdminTopBottom');
			$this->valid_path = is_dir(PLX_ROOT.($this->getParam("folder")));
			if($this->valid_path) {
				# répertoire racine d'installation de PluXml sur le serveur
				$dir = str_replace("\\", "/", dirname($_SERVER["SCRIPT_NAME"]));
				$this->racine = trim(preg_replace("/\/(core|plugins)\/(.*)/", "", $dir), "/")."/";
				$this->racine = $this->racine[0]!="/" ? "/".$this->racine : $this->racine;
				if(!!$this->getParam('admin_files') && preg_match('/('.$this->getParam('admin_files').')/', basename($_SERVER['SCRIPT_NAME'])) || strstr($_SERVER['QUERY_STRING'],'plxMyShop&prod')) {
//if(=! url parametres_users.php | parametres_plugins.php){} todo ?not sur ??
					$this->addHook('AdminTopEndHead', 'AdminTopEndHead');
					$this->addHook('AdminFootEndBody', 'AdminFootEndBody');
				}
				if(!isset($_POST['new_category'])) {
					# conversion des  dans les articles, pages statiques, Categories, Profil et Commentaires
					$this->addHook('plxAdminEditArticle', 'urls2Root');
					$this->addHook('plxAdminEditStatique', 'urls2Root');
					$this->addHook('plxAdminEditCategoriesUpdate', 'urls2Root');
					$this->addHook('plxAdminEditProfil', 'urls2Root');
					$this->addHook('plxMotorAddCommentaire', 'urls2Root');
					$this->addHook('AdminMediasFoot', 'AdminMediasFoot');#TEP
					$this->addHook('plxMyShopEditProductBegin', 'urls2Root');#plxMyShop
				}
			}
		}
	}
#todo from gutum 2.2 + L_NO_JS_STORAGE
	public function AdminMediasFoot(){//changement des onclic target blank en lien retour de tiny du gestionnaire des médias (popup) (Wymeditor base)
?>
<script type="text/javascript">
if (window.parent && window.parent.timixmediaMan && window.parent.tinyMCE){//1 || media manager : gutuma (in compose iframe)
	sessionStorage.setItem('StickyNotes', 'none');//hide StickyNotes plugin notes
	//stackoverflow.com/a/36108449 : onload chained
	if(window.onload != null){var fgfm = window.onload;}
	window.onload=function(){//restore rules
		try{//hide plxAdminBar (from stickyNotes)
			document.getElementById('plxadminbar').style.display = 'none';//hide bar
			new Array('-nocache','-icon','').forEach(function(e){//plxadminbar links
				var ab_css = document.getElementById('plxadminbar'+e+'-css');//link id
				ab_css.parentNode.removeChild(ab_css);//remove
			});
		}catch(e){if(console)console.log('#<?php echo @L_MEDIAS_TITLE . ' : ' . __CLASS__ ?> : hide plxAdminBar error: '+e,e)}
		if(fgfm!=null){fgfm();}//chained onload
	}
	function gu_GetUrlParam(varName, url){//src : roxyfileMan js util.js :  RoxyUtils.GetUrlParam
		var ret = '';
		if(!url)
			url = self.location.href;
		if(url.indexOf('?') > -1){
				url = url.substr(url.indexOf('?') + 1);
				url = url.split('&');
				for(i = 0; i < url.length; i++){
					var tmp = url[i].split('=');
					if(tmp[0] && tmp[1] && tmp[0] == varName){
						ret = tmp[1];
						break;
					}
				}
		}
		return ret;
	}
	function tinymce4(insertPath,input){//src : roxyfileMan js main.js function getPreselectedFile()
		var win = (window.opener?window.opener:window.parent);
		win.document.getElementById(input).value = insertPath;
		if	(typeof(win.ImageDialog) != "undefined") {
			if (win.ImageDialog.getImageData)
				win.ImageDialog.getImageData();
			if (win.ImageDialog.showPreviewImage)
				win.ImageDialog.showPreviewImage(insertPath);
		}
		win.tinyMCE.activeEditor.windowManager.close();
	}
//Get for Memory url query &type &input (is needed after upload)
	var	tinyType = gu_GetUrlParam('type');
	var	where = gu_GetUrlParam('input');
	try{//Fix lost query &type &input after upload
		if(tinyType){
			sessionStorage.<?php echo __CLASS__ ?>tinyType = tinyType;
		}
		else if (sessionStorage.<?php echo __CLASS__ ?>tinyType){
			tinyType = sessionStorage.<?php echo __CLASS__ ?>tinyType;
		}
		if(where){//input
			sessionStorage.<?php echo __CLASS__ ?>where = where;
		}
		else if (sessionStorage.<?php echo __CLASS__ ?>where){
			where = sessionStorage.<?php echo __CLASS__ ?>where;
		}
	}catch(e){
		if(console)console.log('SessionStorage error: '+e,e);//fallback
		if(typeof(Storage !== "undefined")){
			if(tinyType){
				localStorage.setItem("<?php echo __CLASS__ ?>tinyType", tinyType);
			}
			else if (localStorage.getItem("<?php echo __CLASS__ ?>tinyType")){
				tinyType = localStorage.getItem("<?php echo __CLASS__ ?>tinyType");
			}
			if(where){//input
				localStorage.setItem("<?php echo __CLASS__ ?>where", where)
			}
			else if (localStorage.getItem("<?php echo __CLASS__ ?>where")){
				where = localStorage.getItem("<?php echo __CLASS__ ?>where");
			}
			if(console)console.log('Attempt with Storage');
		}else{
			alert('<?php echo @L_MEDIAS_TITLE . ' : ' . __CLASS__ ?> <?php $this->lang('L_NO_JS_STORAGE') ?>');
		}
	}
	var loca = window.parent.location.href.split('/').pop();
	var body = document.getElementsByTagName('body');
	body = body[0];//body.id="medias";
	body.className="mediasManager";
	var tbody = document.getElementsByTagName('tbody');
	var ancres = tbody[0].getElementsByTagName('a');
	for(var i = 0; i < ancres.length; i++){
		if(ancres[i].getAttribute('onclick')){
			var str = ancres[i].getAttribute('onclick');
			var res = str.substr(0, 4);// this OR over[lay]
			if(res == 'this'){
				var type = 'document';
				if ((/\.(gif|jpg|jpeg|png|svg)$/i).test(ancres[i].href))
					type = 'image';
				else if (/\.(tb)\./i.test(ancres[i].href))
					type = 'image';//thumb
				else
					type = 'media';
/*
				if (/\.(mp3|ogg|wav)/i.test(ancres[i].href))
					type = 'media';//audio
				if (/\.(mp4|ogv|webm)/i.test(ancres[i].href))
					type = 'media';//video
*/
				if(tinyType && tinyType != type){
					ancres[i].parentElement.parentElement.style.display="none";//hide tr
				}else{
					ancres[i].setAttribute('onclick','tinymce4(this.href,where);return false;')
					ancres[i].style.color="darkgreen";//gutuma color link
					ancres[i].title = "+ "+ancres[i].title+" > "+loca;
				}
			}
		}
	}
}
</script>
<?php
	}


	/**
	 * Méthode qui affiche un message si le répertoire de stockage des fichiers n'est pas définit dans la config du plugin
	 * @return	stdio
	 * @author	Stephane F
	 **/
	public function AdminTopBottom() {
		$string = '
		if($plxAdmin->plxPlugins->aPlugins["'.__CLASS__.'"]->getParam("folder")=="") {
			echo "<p class=\"warning\">Plugin '.__CLASS__.'<br />'.$this->getLang("L_ERR_FOLDER_NOT_DEFINED").'</p>";
			plxMsg::Display();
		} elseif(!$plxAdmin->plxPlugins->aPlugins["'.__CLASS__.'"]->valid_path) {
			echo "<p class=\"warning\">Plugin '.__CLASS__.'<br />'.$this->getLang("L_ERR_FOLDER_INVALID_DIR").'</p>";
			plxMsg::Display();
		}';
		echo '<?php '.$string.' ?>';
	}

	/**
	 * Méthode qui ajoute la déclaration du script javascript de tinymce	 dans la partie <head>
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminTopEndHead() {
		$string = '
		$_SESSION["FILEMAN_FILES_ROOT"] = "'.$this->racine.trim($this->getParam('folder'), '/').'";
		if($plxAdmin->aConf["userfolders"] AND $_SESSION["profil"]==PROFIL_WRITER) {
			$_SESSION["FILEMAN_FILES_ROOT"] .= "/".$_SESSION["user"];
		}';
		echo '<?php '.$string.' ?>';
?>
		<script src="<?php echo PLX_PLUGINS.__CLASS__; ?>/tinymce/tinymce.min.js?v492c"></script>
		<style style="display:none;">
/* Tiny theme skins/lightgray */
.mce-menubtn.mce-fixed-width span{width:initial !important;max-width:90px}
.mce-btn button {border: 0px solid #eee;}
.mce-menubtn button:hover .mce-txt,.mce-btn button:hover,.mce-btn:hover .mce-ico{color:#efefef;background-color:#555;}
div.mce-menubtn.mce-opened {z-index: 65535 !important;}
/* PluCss */
.mce-fullscreen{z-index: 1000000 !important;}/* plxAdminBar2 +10 : OLD : responsive menu plx + 1 (10000)  */
img {height: auto !important;max-width: 100% !important;}
.in-action-bar {z-index: 9999 !important;}
/* cache le menu principal de PluXml en plein écran (mobile) */
@media (max-width:767px){div.mce-fullscreen{z-index: 10000;}}
/* shortcuts codemirror table */
.mce-container.mce-fullscreen table {border-collapse: initial;}
</style>
<?php
	}

	/**
	 * Fonction qui ajoute la déclaration du script javascript de tinymce en bas de page
	 *
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminFootEndBody() {
		$mode = rtrim(basename($_SERVER['SCRIPT_NAME']),'.php');//statique, article ...
		$extra = trim($this->getParam('extraPlugins'));
		$extraPlugins = ($extra !='' ? ' | '.str_replace(',', ' | ', $extra) : '');
		$height = trim($this->getParam('height'));
		if($height!='') $height = 'height:'.(is_numeric($height) ? $height : '"'.$height.'"').',';

		$tiny_opt = '';
		$spell_opt = '';
		$tiny_tools = $this->getParam('tools');
		$spell_check = $this->getParam('spellcheck');
		//if ($tiny_tools != 'no'){//tinyMCE
		if ($spell_check != 'no'){//spellcheck
			$spell_opt = "		browser_spellcheck: true,".PHP_EOL;//false by default
		}
//		toolslist : 'save anchor autolink charmap code codesample colorpicker contextmenu emoticons fullpage fullscreen help hr image imagetools insertdatetime link lists media nonbreaking noneditable pagebreak paste print searchreplace spellchecker tabfocus table template textcolor textpattern toc visualblocks visualchars wordcount';
		$mce_plug = 'autosave save anchor autolink charmap code codemirror codesample colorpicker emoticons fullscreen help hr image imagetools insertdatetime link lists media nonbreaking noneditable pagebreak paste print searchreplace tabfocus table template textcolor textpattern toc visualblocks visualchars wordcount';//ok


//formatselect | bold italic strikethrough forecolor backcolor | link | alignleft aligncenter alignright alignjustify  | numlist bullist outdent indent  | removeformat

		$mce_too1 = 'fullscreen save insert code | undo redo';#1
		$mce_too1.= ' | cut copy paste | pastetext | removeformat | searchreplace';#1 pasteword cleanup (old?)
		$mce_too1.= ' | charmap | emoticons';#1
		$mce_too1.= ' | table | image | media';#1 iespell (old?)
		$mce_too1.= ' | link unlink | anchor';#1
		$mce_too1.= ' | blockquote | hr';#1
		$mce_too1.= ' | forecolor backcolor';#1 colorpicker?

		$mce_too2 = 'bold italic underline strikethrough';#2
		$mce_too2.= ' | alignleft alignright';#2
		$mce_too2.= ' | aligncenter alignjustify';#2
		$mce_too2.= ' | sub sup';#2
		$mce_too2.= ' | outdent indent | bullist numlist';#2

		$mce_too3 = 'formatselect fontselect fontsizeselect';#3
		$mce_too3.= ' | visualblocks | print | help';#3

		switch ($tiny_tools){
			case 'menu':
				$tiny_opt = "		toolbar: false,".PHP_EOL;//false by default
				break;
			case 'tools':
				$tiny_opt .= "		menubar:false,".PHP_EOL;
			case 'all':
				$tiny_opt .= "
			toolbar: '".$mce_too1." | ".$mce_too2." | ".$mce_too3.$extraPlugins."',".PHP_EOL;//v4 emulate old advanced theme
		}
 //insert templates of theme/myPersonalTheme/templates
		echo "<?php
		\$tinyTemplates = false;
		if(\$themeTemplates = is_dir(PLX_ROOT.'themes/'.\$plxAdmin->style.'/tiny/'))
			\$themeTemplates = array_diff(scandir(PLX_ROOT.'themes/'.\$plxAdmin->style.'/tiny/'), array('.', '..'));
		if(\$themeTemplates){
			\$tinyTemplates = '
			[';
			foreach(\$themeTemplates as \$tinyTemplate ){
				\$tinyTemplates .= '
				{\"title\": \"'.plxUtils::strCheck(\$tinyTemplate).'\", \"description\": \"'.plxUtils::strCheck(\$tinyTemplate).'\", \"url\": \"'.PLX_ROOT.'themes/'.\$plxAdmin->style.'/tiny/'.plxUtils::strCheck(\$tinyTemplate).'\"}';
			\$tinyTemplates .= '
			]';
			}
		}
		?>";
?>
<script type='text/javascript'>
	tinyMCE.init({// General options
//		mode : 'textareas',
		selector: 'textarea',
//		inline: true,//theme: 'inlite' (not with textarea?)
		skin: 'lightgray',
		theme: 'modern',//modern = error on load font 4.7.11.fixed , test mobile
		language: '<?php echo $this->default_lang ?>',
		<?php echo $height ?>
/*
		toolbar_items_size: "large",//large 4 mobile ::: bug \w small + ==  in T471 (tinymce-small)
		fontsize_formats: "8px 10px 12px 14px 15px 16px 18px 20px 24px 26px 30px 36px",
		entity_encoding : "named",
		entities : "160,nbsp",
		element_format : "html",
*/
		image_description: true,
		image_title: true,
		image_dimensions: false,
		image_advtab: true,

/*
//		www.tinymce.com/docs/mobile/ (4.7+) [beta] dont work with 'beta-mobile' name
		mobile: {
			theme: 'mobile',//
			plugins: [ 'autosave', 'lists', 'autolink' ],
			toolbar: [ 'undo', 'redo', 'bold', 'italic', 'underline', 'link', 'unlink', 'image', 'bullist', 'numlist', 'styleselect', 'fontsizeselect ', 'forecolor', 'removeformat' ]

			//plugins: 'autosave lists autolink',
			//toolbar: 'undo redo bold italic underline link unlink image bullist numlist styleselect fontsizeselect  forecolor removeformat'
		},
*/
		plugins : '<?php echo $mce_plug ?>',<?php echo $tiny_opt.$spell_opt ?>
		extended_valid_elements:'script[language|type|src]',
		content_css : 'themes/<?php echo '<?php echo $plxAdmin->style; ?>'; ?>/editor.css',// Example word content CSS (should be your site CSS) this one removes paragraph margins

//		www.tinymce.com/docs/plugins/template/#example
		<?php echo '<?php echo $themeTemplates ? "templates:".$tinyTemplates."," : ""; ?>'; ?>

//		www.tinymce.com/docs/plugins/paste/#paste_data_images
		paste_data_images: true,
		//paste_as_text: true,// activate opt on init

//		www.tinymce.com/docs/advanced/handle-async-image-uploads/
		images_upload_url: '<?php echo PLX_PLUGINS.__CLASS__ ?>/ajax_upload.php',//'postAcceptor.php', //www.tinymce.com/docs/advanced/php-upload-handler/
		images_upload_base_path: '<?php echo PLX_ROOT.$this->getParam('folder'); ?>',
		images_upload_credentials: true,

		autosave_ask_before_unload: true,
		save_onsavecallback: function () {//Fix : on save normal event call (button)
//			console.log('save callBack');
			var save_forms = document.getElementsByName("update");// article
			if(!save_forms[0])
				save_forms = document.getElementsByName("draft");// article
				if(!save_forms[0]){
					var inputs = document.getElementsByTagName('input');// other
					for (var i = 0; i < inputs.length; i++) {
						if (inputs[i].getAttribute('type') == 'submit') {
							inputs[i].click();
							return;
						}
					}
				}
			save_forms[0].click();
		},

<?php if($mode=='statique' OR $mode=='parametres_edittpl'): ?>
		//protect: [/<\?php[\s\S]*?\?>/g],// Protect php code OLD
//www.tinymce.com/docs/configure/content-filtering/#protect
//!\ Old&New:/ if php is in attribute of tag, protect dont remove &lt;!--mce:protected ... --&gt;
// sample (edit article.php of theme) ::: <time datetime="&lt;!--mce:protected %3C%3Fphp%20%24plxShow-%3EartDate%28%27%23num_year%284%29-%23num_month-%23num_day%27%29%3B%20%3F%3E--&gt;"> ::: <article id="post-&lt;!--mce:protected %3C%3Fphp%20echo%20%24plxShow-%3EartId%28%29%3B%20%3F%3E--&gt;"
		protect: [
//				/\<\/?(if|endif)\>/g,  // Protect <if> & </endif>
//				/\<xsl\:[^>]+\>/g,  // Protect <xsl:...>
				/<\?php.*?\?>/g  // Protect php code
		],
		mode: 'php',
<?php endif; ?>

//		extendedValidElements: "@[id|class|style],-div[id|dir|class|align|style],ins[datetime|cite],-ul[class|style],-li[class|style],span[id|class|style|title|onclick]";//https://stackoverflow.com/questions/16421816/tinymce-not-add-the-onclick-event-in-the-tag#16436211
//		extended_valid_elements : 'img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name|title|script|type]',

		//file_browser_callback: RoxyFileBrowser,
		file_browser_callback: timixmediaMan,//PluXml media manager (gutuma 2.2.0 compose.php) #TEP

		codemirror: {
<?php if($this->getParam('cmfullscreen')): ?>
			fullscreen: true,/* Default setting is false */
<?php endif; ?>
			indentOnInit: true,// Whether or not to indent code on init.
			path: '../../../codemirror',// Path to CodeMirror distribution
			config: {
				theme: '<?php echo $this->getParam('cmtheme') ?>',// Set this to the theme you wish to use (codemirror themes) //default,neo , abcdef ...
				lineNumbers: true,// Whether or not you want to show line numbers
				lineWrapping: true,// Whether or not you want to use line wrapping
				matchBrackets: true,// Whether or not you want to highlight matching braces
				autoCloseTags: true,// Whether or not you want tags to automatically close themselves
				autoCloseBrackets: true,// Whether or not you want Brackets to automatically close themselves
				enableSearchTools: true,// Whether or not to enable search tools, CTRL+F (Find), CTRL+SHIFT+F (Replace), CTRL+SHIFT+R (Replace All), CTRL+G (Find Next), CTRL+SHIFT+G (Find Previous)
				enableCodeFolding: true,// Whether or not you wish to enable code folding (requires 'lineNumbers' to be set to 'true')
				enableCodeFormatting: true,// Whether or not to enable code formatting
				autoFormatOnStart: true,// Whether or not to automatically format code should be done when the editor is loaded
				autoFormatOnModeChange: true,// Whether or not to automatically format code should be done every time the source view is opened
				autoFormatOnUncomment: true,// Whether or not to automatically format code which has just been uncommented
//				mode: 'application/x-httpd-php',// Define the language specific mode 'htmlmixed' for html including (css, xml, javascript), 'application/x-httpd-php' for php mode including html, or 'text/javascript' for using java script only #OLD
<?php if($mode=='statique' OR $mode=='parametres_edittpl'): //https://github.com/w8tcha/CKEditor-CodeMirror-Plugin/issues/152#issuecomment-489885692 ?>
				mode: 'application/x-httpd-php',// { name: 'application/x-httpd-php', globalVars: true },
<?php else: ?>
				mode: { name: 'htmlmixed', globalVars: true },
<?php endif; ?>
				showSearchButton: true,// Whether or not to show the search Code button on the toolbar				showTrailingSpace: true,// Whether or not to show Trailing Spaces
				highlightMatches: true,// Whether or not to highlight all matches of current word/selection
				showFormatButton: true,// Whether or not to show the format button on the toolbar
				showCommentButton: true,// Whether or not to show the comment button on the toolbar
				showUncommentButton: true,// Whether or not to show the uncomment button on the toolbar
				showAutoCompleteButton: true,// Whether or not to show the showAutoCompleteButton button on the toolbar
				styleActiveLine: true// Whether or not to highlight the currently active line
			},
			width: 800,// Default value is 800
			height: 600,// Default value is 550
			saveCursorPosition: true ,// Insert caret marker
			jsFiles: [// Additional JS files to load
				'mode/clike/clike.js',
				'mode/css/css.js',
				'mode/javascript/javascript.js',
				'mode/php/php.js'
			],
//			cssFiles: [// Additional css files to load
//				'theme/solarized.css'
//			]
		}//fi CodeMirror config
	}).then(function(editors) {// Méthode qui ajoute le toggle switch & remplace les "data/media" en "../../data/media" (PLX_ROOT+folder) après que tiny soit instancié
// what to do after editors init
		var tips = '';
		for(ed in editors){
//console.log(editor id: '+editors[ed].id);
// v4.x toggle editor https://stackoverflow.com/a/30664473 	tinymce.EditorManager.execCommand('mceToggleEditor', true, editors[ed].id);//disable editor on launch
			var tog = document.createElement('div');
			var gle = document.getElementById(editors[ed].id);// xahlee.info/js/js_insert_after.html
			tog.innerHTML = '<a href="javascript:;" onclick="tinymce.execCommand(\'mceToggleEditor\', true, \''+editors[ed].id+'\');"><img title="<?php $this->lang('L_TOGGLE') ?>" alt="[Off/On Tiny]" style="vertical-align:middle;margin-left:4px;" src="<?php echo PLX_PLUGINS.__CLASS__; ?>/img/toggle.png" /><?php $this->lang('L_TOGGLE') ?></a>';// linuxmint icon shutdown sys ;)
			gle.parentNode.insertBefore(tog, gle.nextSibling);// add after existing node (textareas)
//			gle.parentNode.insertBefore(tog, gle);// add before existing node (textareas)

// pour de bonnes urls relative a l'admin de PluXml
			tips = editors[ed].getContent();//.contentDocument.body.outerHTML
// Use func to set content ;). Replace directly in tiny contentDocument break onChange save plugin ::: editors[ed].contentDocument.body.outerHTML = tips.split(...).join(...);
	    		editors[ed].setContent(tips.split('<?php echo $this->getParam('folder') ?>').join('<?php echo PLX_ROOT.$this->getParam('folder') ?>'));//global replace thanks bobince : stackoverflow.com/a/542305
/*// thx Thariama https://stackoverflow.com/a/8507292 (1st ok)
			tiny = tinymce.get(editors[ed].id);
			tips = tiny.getContent();//editors[ed].contentDocument.body.outerHTML;// break text onChange detection
			tips = tips.split('<?php echo $this->getParam('folder') ?>').join('<?php echo PLX_ROOT.$this->getParam('folder') ?>');//global replace, thanks bobince stackoverflow.com/a/542305
			tiny.setContent(tips);
*/
		}
	});//fi tinyinit
//Inspiré par RoxyFileBrowser (field_name, url, type, win)
	function timixmediaMan(field_name, url, type, win) {//gutuma 2.2.0 IDÉA
		var timixMedMan = '<?php echo plxUtils::getRacine() ?>core/admin/medias.php';//?integration=tinymce4
		if (timixMedMan.indexOf("?") < 0) {
			timixMedMan += "?type=" + type;
		}
		else {
			timixMedMan += "&type=" + type;
		}
		timixMedMan += '&input=' + field_name;<?php // + '&value=' + win.document.getElementById(field_name).value;
/* js hide by php comment
		if(tinyMCE.activeEditor.settings.language){
			timixMedMan += '&langCode=' + tinyMCE.activeEditor.settings.language;
		}
*/
?>
		tinyMCE.activeEditor.windowManager.open({
		file: timixMedMan,
		title: '<?php echo L_MEDIAS_TITLE ?> : <?php echo __CLASS__ ?>',
		width: window.innerWidth-150,//850
		height: window.innerHeight-150,//650
		resizable: "yes",
		plugins: "media",
		inline: "yes",
		close_previous: "no",
		}, {window: win,input: field_name});
		return false;
	}
</script>
<?php
	}

	/**
	 * Méthode qui remplace les "../../data/media" par "data/media" (PLX_ROOT+folder) a l'enregistrement
	 * @author	Thomas Ingles
	 **/
	public function urls2Root() {//return;//2dbg
		echo '<?php /* '.__CLASS__.'->'.__FUNCTION__.'() */'; ?>
		$edRoot = array(PLX_ROOT."blob:",PLX_ROOT."<?php echo $this->getParam('folder')?>");
		$edMedia = array("blob:","<?php echo $this->getParam('folder')?>");
		if(isset($content['chapo']))
			$content['chapo'] = str_replace($edRoot, $edMedia, trim($content['chapo']));
		if(isset($content['content']))//art & coms
			$content['content'] = str_replace($edRoot, $edMedia, trim($content['content']));

		if(isset($lng) && isset($content['content'.$lng]))//plxMyShop 0.13.1
			$content['content'.$lng] = str_replace($edRoot, $edMedia, trim($content['content'.$lng]));

		if(isset($cat_id))// plxAdminEditCategoriesUpdate
			$this->aCats[$cat_id]["description"] = str_replace($edRoot, $edMedia, trim($this->aCats[$cat_id]["description"]));

		if(isset($content["profil"])){// Hook plugins plxAdminEditProfil
			$this->aUsers[$_SESSION["user"]]["infos"] = $content["content"];
		}
?><?php
	}
}
